#pragma once
#include "Image.h"
#include "Anime.h"
#include "Font.h"
#include "Screen.h"

namespace DXFW
{
///<summary>rbg}bvtHgNX</summary>
///rbg}bvtHgʏ̃tHgƓlɈNXB
///<example>
///[TvR[h:]<BR>
///Tv<BR>
///<code>
///int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///{<BR>
///	if( !Dx::Initialise() ) return -1;<BR>
///	Dx::End();<BR>
///	return 0;<BR>
///}<BR>
///</code>	
///</example>
class BmpFont : public IFont
{
private:
	ImagePack *divImageNumber;
	ImagePack *divImageAlphabetCapital;
	ImagePack *divImageAlphabetLow;

	bool isNumber;
	bool isAlphabetCapital;
	bool isAlphabetLow;
	int numberHeight;
	int numberWidth;
		
	int alphabetCapitalHeight;
	int alphabetCapitalWidth;

	int alphabetLowHeight;
	int alphabetLowWidth;

	int maxHeight;

	int enterSpace;

	int spaceWidth;
public:
	BmpFont():
		isNumber(false),
		isAlphabetCapital(false),
		isAlphabetLow(false),
		enterSpace(0)
	{}

	~BmpFont(){};
		
	///<summary>s̍擾</summary>
	///s̍擾
	int GetEnterHeight() const
	{
		return this->enterSpace;
	}
			
	///<summary>s̍ݒ</summary>
	///0̏ꍇAs̏㉺B
	///l0
	void SetEnterHeight(int height)
	{
		this->enterSpace;
	}
			
	///<summary>tHgݒ</summary>
	///ɎgImagePackݒ肷B
	///0`9̏10ׂ摜g
	bool SetNumber( ImagePack &pC[W )
	{
		if( pC[W.GetSize() < 10 ) return false;

		this->divImageNumber = &pC[W;

		this->numberWidth = pC[W.GetWidth();
		this->numberHeight = pC[W.GetHeight();
		this->spaceWidth = pC[W.GetWidth();

		this->maxHeight   = max( this->maxHeight , pC[W.GetHeight() );

		this->isNumber = true;

		return true;
	}
			
	///<summary>p啶tHgZbg</summary>
	///p啶ɎgImagePackݒ肷B
	///A`Z̏26ׂ摜gB
	bool SetAlphabetCapital(ImagePack &啶pC[W )
	{
		if( 啶pC[W.GetSize() < 26 ) return false;

		this->divImageAlphabetCapital = &啶pC[W;

		this->alphabetCapitalWidth = 啶pC[W.GetWidth();
		this->alphabetCapitalHeight = 啶pC[W.GetHeight();
		this->spaceWidth = 啶pC[W.GetWidth();
	
		this->maxHeight   = max( this->maxHeight , 啶pC[W.GetHeight() );
				
		this->isAlphabetCapital = true;

		return true;
	}
			
	///<summary>ptHgZbg</summary>
	///pɎgImagePackݒ肷B
	///A`Z̏26ׂ摜gB
	bool SetAlphabetLow(ImagePack &pC[W )
	{
		if( pC[W.GetSize() < 26 ) return false;

		this->divImageAlphabetLow = &pC[W;

		this->alphabetLowWidth = pC[W.GetWidth();
		this->alphabetLowHeight = pC[W.GetHeight();
		this->spaceWidth = pC[W.GetWidth();
				
		this->maxHeight   = max( this->maxHeight , pC[W.GetHeight() );
				
		this->isAlphabetLow = true;
		return true;
	}
			
	///<summary>tŕ`</summary>
	///rbg}bvtHgȂ̂ŁAF͖
	bool Draw(int x , int y , int rgb , const char *str , ...) const
	{
		char bufstr[1024];
		va_list args;
		va_start(args,str);
		vsprintf_s( bufstr , 1024 ,str, args );
		va_end(args);

		int i = 0;
		int addX = 0;
		int addY = this->maxHeight;

		while( bufstr[i] != NULL)
		{
			if( bufstr[i] >= '0' && bufstr[i] <= '9' && this->isNumber)
			{
				this->divImageNumber[0][ bufstr[i] - '0' ]->DrawExtend(
					x + addX,
					y + addY - this->numberHeight  ,
					x + addX + this->numberWidth  ,
					y + addY  );

				addX += this->numberWidth;
			}
			else if (bufstr[i] >= 'A' && bufstr[i] <= 'Z' && this->isAlphabetCapital)
			{

				this->divImageAlphabetCapital[0][ bufstr[i] - 'A' ]->DrawExtend
					(
					x + addX ,
					y + addY - this->alphabetCapitalHeight ,
					x + addX + this->alphabetCapitalWidth ,
					y + addY  
					);

				addX += this->alphabetCapitalWidth;

			}
			else if (bufstr[i] >= 'a' && bufstr[i] <= 'z' && this->isAlphabetLow)
			{

				this->divImageAlphabetLow[0][ bufstr[i] - 'a']->DrawExtend
					(
					x + addX,
					y + addY - this->numberHeight  ,
					x + addX + this->numberWidth  ,
					y + addY
					);

				addX += this->alphabetLowWidth;

			}
			else if (bufstr[i] == ' ')
			{
				addX += this->spaceWidth;
			}
			else if (bufstr[i] == '\\' && bufstr[i+1] == 'n' )
			{
				addY += this->maxHeight + this->enterSpace;
			}
			i++;
			if(i == strlen(bufstr) ) break;
		}
		return true;
	}
	bool ZMask(int x , int y , ZMaskType Z}XN^Cv , const char *str , ...) const
	{
		char bufstr[1024];
		va_list args;
		va_start(args,str);
		vsprintf_s( bufstr , 1024 ,str, args );
		va_end(args);

		int i = 0;
		int addX = 0;
		int addY = this->maxHeight;

		while( bufstr[i] != NULL)
		{
			if( bufstr[i] >= '0' && bufstr[i] <= '9' && this->isNumber)
			{
				this->divImageNumber[0][ bufstr[i] - '0' ]->ZMaskExtend
					(
						x + addX,
						y + addY - this->numberHeight  ,
						x + addX + this->numberWidth  ,
						y + addY ,
						Z}XN^Cv
					);
				addX += this->numberWidth;
			}
			else if (bufstr[i] >= 'A' && bufstr[i] <= 'Z' && this->isAlphabetCapital)
			{

				this->divImageAlphabetCapital[0][ bufstr[i] - 'A' ]->ZMaskExtend
					(
						x + addX ,
						y + addY - this->alphabetCapitalHeight ,
						x + addX + this->alphabetCapitalWidth ,
						y + addY ,
						Z}XN^Cv
					);

				addX += this->alphabetCapitalWidth;

			}
			else if (bufstr[i] >= 'a' && bufstr[i] <= 'z' && this->isAlphabetLow)
			{

				this->divImageAlphabetLow[0][ bufstr[i] - 'a']->ZMaskExtend
					(
						x + addX,
						y + addY - this->numberHeight  ,
						x + addX + this->numberWidth  ,
						y + addY,
						Z}XN^Cv
					);

				addX += this->alphabetLowWidth;

			}
			else if (bufstr[i] == ' ')
			{
				addX += this->spaceWidth;
			}
			else if (bufstr[i] == '\\' && bufstr[i+1] == 'n' )
			{
				addY += this->maxHeight + this->enterSpace;
			}
			i++;
			if(i == strlen(bufstr) ) break;
		}
		return true;
	}
	
	///<summary>g嗦w肵ĕ`</summary>
	///rbg}bvtHgȂ̂ŁAF͖
	bool DrawExtend( int x , int y , double extRateX , double extRateY , int rgb , const char *str , ...) const
	{
		char bufstr[1024];
		va_list args;
		va_start(args,str);
		vsprintf_s( bufstr , 1024 ,str, args );
		va_end(args);

		int i = 0;
		double addX = 0;
		double addY = this->maxHeight;

		while( bufstr[i] != NULL)
		{
			if( bufstr[i] >= '0' && bufstr[i] <= '9' && this->isNumber)
			{

				this->divImageNumber[0][bufstr[i] - '0' ]->DrawExtend
				(
					x + int(addX * extRateX ) ,
					y + int((addY - this->numberHeight) * extRateY) ,
					x + int((addX + this->numberWidth ) * extRateX ),
					y + int(addY * extRateY )
				);

				addX += this->numberWidth;

			}
			else if (bufstr[i] >= 'A' && bufstr[i] <= 'Z' && this->isAlphabetCapital)
			{

				this->divImageAlphabetCapital[0][ bufstr[i] - 'A' ]->DrawExtend
				(
					x + int(addX * extRateX ) ,
					y + int((addY - this->alphabetCapitalHeight) * extRateY) ,
					x + int((addX + this->alphabetCapitalWidth) * extRateX ),
					y + int(addY * extRateY )
				);

				addX += this->alphabetCapitalWidth;

			}
			else if (bufstr[i] >= 'a' && bufstr[i] <= 'z' && this->isAlphabetLow)
			{
				this->divImageAlphabetLow[0][ bufstr[i] - 'a']->DrawExtend
				(
					x + int(addX * extRateX ) ,
					y + int((addY - this->alphabetLowHeight) * extRateY ) ,
					x + int((addX + this->alphabetLowWidth) * extRateX ),
					y + int(addY * extRateY )
				);

				addX += this->alphabetLowWidth;
			}
			else if (bufstr[i] == ' ')
			{
				addX += this->spaceWidth;
			}
			else if (bufstr[i] == '\\' && bufstr[i+1] == 'n' )
			{
				addY += this->maxHeight + this->enterSpace;
			}
			i++;
			if(i == strlen(bufstr) ) break;
		}
		return true;
	}		
	bool ZMaskExtend( int x , int y , double extRateX , double extRateY , ZMaskType Z}XN^Cv, const char *str , ...) const
	{
		char bufstr[1024];
		va_list args;
		va_start(args,str);
		vsprintf_s( bufstr , 1024 ,str, args );
		va_end(args);

		int i = 0;
		double addX = 0;
		double addY = this->maxHeight;

		while( bufstr[i] != NULL)
		{
			if( bufstr[i] >= '0' && bufstr[i] <= '9' && this->isNumber)
			{

				this->divImageNumber[0][bufstr[i] - '0' ]->ZMaskExtend
				(
					x + int(addX * extRateX ) ,
					y + int((addY - this->numberHeight) * extRateY) ,
					x + int((addX + this->numberWidth ) * extRateX ),
					y + int(addY * extRateY ),
					Z}XN^Cv
				);

				addX += this->numberWidth;

			}
			else if (bufstr[i] >= 'A' && bufstr[i] <= 'Z' && this->isAlphabetCapital)
			{

				this->divImageAlphabetCapital[0][ bufstr[i] - 'A' ]->ZMaskExtend
				(
					x + int(addX * extRateX ) ,
					y + int((addY - this->alphabetCapitalHeight) * extRateY) ,
					x + int((addX + this->alphabetCapitalWidth) * extRateX ),
					y + int(addY * extRateY ),
					Z}XN^Cv
				);

				addX += this->alphabetCapitalWidth;

			}
			else if (bufstr[i] >= 'a' && bufstr[i] <= 'z' && this->isAlphabetLow)
			{
				this->divImageAlphabetLow[0][ bufstr[i] - 'a']->ZMaskExtend
				(
					x + int(addX * extRateX ) ,
					y + int((addY - this->alphabetLowHeight) * extRateY ) ,
					x + int((addX + this->alphabetLowWidth) * extRateX ),
					y + int(addY * extRateY ),
					Z}XN^Cv
				);

				addX += this->alphabetLowWidth;
			}
			else if (bufstr[i] == ' ')
			{
				addX += this->spaceWidth;
			}
			else if (bufstr[i] == '\\' && bufstr[i+1] == 'n' )
			{
				addY += this->maxHeight + this->enterSpace;
			}
			i++;
			if(i == strlen(bufstr) ) break;
		}
		return true;
	}
	
};
}