#pragma once
#include <DxLib.h>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include "IFont.h"
#define NULL_HANDLE -1

namespace DXFW
{
/// <summary>tHg̎</summary>
enum class FontType
{	
	Normal = DX_FONTTYPE_NORMAL,
	Edge = DX_FONTTYPE_EDGE,
	AntiAliase = DX_FONTTYPE_ANTIALIASING,
	AntiAliaseEdge = DX_FONTTYPE_ANTIALIASING_EDGE,
};

///<summary>tHgNX</summary>
///
///<example>
///[TvR[h:]<BR/>
///Tv
///<code>
///int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///{<BR>
///	Dx::Initialise();<BR/>
///	Dx::End();<BR/>
///	return 0;<BR/>
///}<BR/>
/// </code>	
/// </example>
class Font : public IFont
{
private:
	int size;
	int thick;
	int handle;
	int enterHeight;
public:
	Font():
		size(0),
		thick(0),
		handle(NULL_HANDLE),
		enterHeight(0)
	{}
	
	///<summary>tHgf[^쐬</summary>
	///File::LoadQ
	Font(const char *tHg,int 傫 ,int  , int s, FontType tHg^Cv = FontType::Normal)
	{
		Font::Load( tHg , 傫 ,  , s , tHg^Cv);
	}
			
	///<summary>ɃtHg쐬</summary>
	///0`9ŎwA傫Ƒ-1ɂƃftHgɂȂ
	///s0̏ꍇAs̕㉺B
	bool Load(const char *tHg,int 傫 ,int  , int s, FontType tHg^Cv = FontType::Normal)
	{
		if( this->handle != NULL_HANDLE ) DxLib::DeleteFontToHandle(this->handle);
		this->handle = DxLib::CreateFontToHandle(tHg,傫,,(int)tHg^Cv);
		this->size = 傫;
		this->thick = ;
		this->enterHeight = s;
		return ( handle != -1 );
	}
			
	///<summary>tHgJ</summary>
	bool Release() const
	{
		return !DxLib::DeleteFontToHandle(this->handle);
	}
			
	///<summary>tHg̃nh擾</summary>
	int GetHandle() const
	{
		return this->handle;
	}
	
	/// <summary>傫擾</summary>
	int GetSize() const
	{
		return this->size;
	}
			
	/// <summary>擾</summary>
	int Getthick() const
	{
		return this->thick;
	}
			
	/// <summary>`掞̕擾</summary>
	int GetDrawStringWidth(int strLen ,const char *str , ... ) const
	{
		char bufstr[1024];

		va_list args;
		va_start(args,str);
		vsprintf_s( bufstr , 1024,str, args );
		va_end(args);

		return DxLib::GetDrawStringWidthToHandle(bufstr,strLen,this->handle);
	}

	/// <summary>tŕ`</summary>
	bool Draw(int x , int y ,  int rgb ,const char *str , ...) const
	{
		//sR[hL
		char bufstr[1024];
		va_list args;
		va_start(args,str);
		vsprintf_s( bufstr , 1024 ,str, args );
		va_end(args);


		char *pstr,*stro;
		strcpy_s(bufstr,1024,str);

		stro = strtok_s(bufstr,"\n",&pstr);

		while(stro != NULL)
		{
			DxLib::DrawStringToHandle(x,y,stro,rgb,handle);
			stro = strtok_s(NULL,"\n",&pstr);
			y += this->enterHeight;
		}

		return true;
	}	
	bool ZMask(int x , int y , ZMaskType Z}XN^Cv , const char *str , ...) const
	{
		//sR[hL
		char bufstr[1024];
		va_list args;
		va_start(args,str);
		vsprintf_s( bufstr , 1024 ,str, args );
		va_end(args);

		char *pstr,*stro;
		strcpy_s(bufstr,1024,str);

		stro = strtok_s(bufstr,"\n",&pstr);

		while(stro != NULL)
		{
			DxLib::DrawStringToHandleToZBuffer(x,y,stro,handle, (int)Z}XN^Cv);
			stro = strtok_s(NULL,"\n",&pstr);
			y += this->enterHeight;
		}

		return true;
	}
	

	/// <summary>g嗦w肵ĕ`</summary>
	bool DrawExtend(int x , int y , double extRateX , double extRateY ,  int rgb ,const char *str , ... ) const
	{
		char bufstr[1024];
		va_list args;
		va_start(args,str);
		vsprintf_s( bufstr , 1024 ,str, args );
		va_end(args);

		char *pstr,*stro;
		strcpy_s(bufstr,1024,str);

		stro = strtok_s(bufstr,"\n",&pstr);

		while(stro != NULL)
		{
			DxLib::DrawExtendStringToHandle(x,y,extRateX , extRateY , stro , rgb , handle );
			stro = strtok_s(NULL,"\n",&pstr);
			y += this->enterHeight;
		}

		return true;
	}		
	bool ZMaskExtend(int x , int y , double extRateX , double extRateY , ZMaskType Z}XN^Cv ,const char *str , ...) const
	{
		char bufstr[1024];
		va_list args;
		va_start(args,str);
		vsprintf_s( bufstr , 1024 ,str, args );
		va_end(args);

		char *pstr,*stro;
		strcpy_s(bufstr,1024,str);

		stro = strtok_s(bufstr,"\n",&pstr);

		while(stro != NULL)
		{
			DxLib::DrawExtendStringToHandleToZBuffer(x,y,extRateX , extRateY , stro , handle , (int)Z}XN^Cv );
			stro = strtok_s(NULL,"\n",&pstr);
			y += this->enterHeight;
		}

		return true;
	}
};
}