#pragma once
#include<DxLib.h>
#include<vector>
#include<string>
#include<memory>
#define NULL_HANDLE -1

namespace DXFW
{
	
/// <summary>Z}XN̎</summary>
enum class ZMaskType
{
	Clear = DX_ZWRITE_CLEAR,///
	Mask  = DX_ZWRITE_MASK,///
};

/// <summary></summary>
enum class RGBA
{
	SrcR = DX_RGBA_SELECT_SRC_R,///
	SrcG = DX_RGBA_SELECT_SRC_G,///
	SrcB = DX_RGBA_SELECT_SRC_B,///
	SrcA = DX_RGBA_SELECT_SRC_A,///
	BlendR = DX_RGBA_SELECT_BLEND_R,///
	BlendG = DX_RGBA_SELECT_BLEND_G,///
	BlendB = DX_RGBA_SELECT_BLEND_B,///
	BlendA = DX_RGBA_SELECT_BLEND_A///
};

/// <summary></summary>
enum class ClipType
{
	Less    = DX_CMP_LESS,///
	Greater = DX_CMP_GREATER///
};

///	<summary>摜NXB[ht@C̕`擙B</summary>
///	<example>
///	[TvR[h:]<BR>
/// Tv<BR>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///	{<BR>
///		Dx::Initialise();<BR>
///		Dx::End();<BR>
///		return 0;<BR>
/// }<BR>
/// </code>	
/// </example>
class Image
{
friend class Anime;
friend class ImagePack;

private:
	bool isScreen;
	bool isAlphaChannel;
	int handle;
	bool isTrans;

	int width;
	int height;
	Image(int handle):
		handle(handle),
		isTrans(true),
		isAlphaChannel(false),
		isScreen(false)	
	{
		DxLib::GetGraphSize( this->GetHandle() , &width , &height );
	}
public:
	Image():
		handle(NULL_HANDLE),
		isTrans(true),
		isAlphaChannel(false),
		isScreen(false),
		width(0),
		height(0)
	{};

	///<summary>摜֓ǂݍ</summary>
	Image(const char *t@C)
	{
		Image::Load(t@C);
	}

	/// <summary>̃C[W쐬</summary>
	Image(int  ,int  , bool ߃tO , bool XN[ptO , bool `ltO ):
		isTrans(߃tO),
		isScreen(XN[ptO),
		isAlphaChannel(`ltO)
	{
		if( XN[ptO )
		{
			this->handle = DxLib::MakeScreen(  ,  , `ltO);
		}
		else
		{
			this->handle = DxLib::MakeGraph(  ,  );
		}
		DxLib::GetGraphSize( this->GetHandle() , & , & );
	}

	/// <summary>摜֓ǂݍ</summary>
	bool Load(const char *t@C)
	{
		if( this->handle != NULL_HANDLE) DxLib::DeleteGraph(this->handle);
		this->handle = DxLib::LoadGraph(t@C);
		this->isTrans = true;
		this->isScreen = false;
				
		DxLib::GetGraphSize( this->GetHandle() , &width , &height );
		return ( this->handle != -1 );
	}

	/// <summary>C[WJ</summary>
	bool Release()
	{
		return (DxLib::DeleteGraph(this->handle) == 0);
	}
			
	/// <summary>̃C[W쐬</summary>
	int Make(int width,int ,bool isTrans = true ,bool isScreen = false , bool isAlphaChannel = true )
	{
		if( this->handle != NULL_HANDLE) DxLib::DeleteGraph(this->handle);
		if( isScreen )
		{
			this->handle = DxLib::MakeScreen( width ,  , isAlphaChannel);
		}
		else
		{
			this->handle = DxLib::MakeGraph( width ,  );
		}
		this->isTrans = isTrans;
		this->isScreen = isScreen;
		this->isAlphaChannel = isAlphaChannel;
		this->width = width;
		this->height = ;

		return this->handle;
	}

	/// <summary>C[ẄꕔRs[āAʃC[W쐬</summary>
	int Copy(const Image& img,int x , int y,int width,int )
	{
		this->handle = DxLib::DerivationGraph( x , y , width ,  , img.handle);
		this->isTrans = img.isTrans;
		this->isScreen = false;
		this->isAlphaChannel = false;
		this->width = width;
		this->height = ;
		return this->handle;
	}

	/// <summary>nh擾</summary>
	int GetHandle() const
	{
		return this->handle;
	}
			
	/// <summary>wWɕ`</summary>
	bool Draw(int XW,int YW , bool ]tO = false) const
	{
		if( ]tO )
		{
			return !DxLib::DrawTurnGraph( XW , YW , this->GetHandle() , this->isTrans );
		}else{					
			return !DxLib::DrawGraph( XW , YW , this->GetHandle() , this->isTrans );
		}
	}
	bool ZMask(int XW,int YW , ZMaskType Z}XN^Cv ,  bool ]tO = false) const
	{
		if( ]tO )
		{
			return !DxLib::DrawTurnGraphToZBuffer( XW , YW , this->GetHandle() , (int)Z}XN^Cv );
		}else{
			return !DxLib::DrawGraphToZBuffer( XW , YW , this->GetHandle() , (int)Z}XN^Cv );
		}
	}	

	/// <summary>w`ɕ`</summary>
	bool DrawExtend(int XWA,int YWA,int XWB,int YWB ) const
	{
		return !DxLib::DrawExtendGraph( XWA, YWA, XWB, YWB , this->GetHandle() , this->isTrans );			
	}
	bool ZMaskExtend(int XWA,int YWA,int XWB,int YWB  , ZMaskType Z}XN^Cv) const
	{
		return !DxLib::DrawExtendGraphToZBuffer( XWA, YWA, XWB, YWB , this->GetHandle() , (int)Z}XN^Cv );
	}
		
	/// <summary>pxAg嗦w肵ĕ`</summary>
	bool DrawRotate(int x,int y,double g嗦,double px,bool ]tO = false ) const
	{
		return !DxLib::DrawRotaGraph( x , y , g嗦 , px , this->GetHandle() , this->isTrans , ]tO );
	}
	bool DrawRotateZMask(int x,int y,double g嗦,double px , ZMaskType Z}XN^Cv ,bool ]tO = false ) const
	{
		return !DxLib::DrawRotaGraphToZBuffer( x , y , g嗦 , px , this->GetHandle() , (int)Z}XN^Cv , ]tO );
	}

	/// <summary>]ApxAg嗦w肵ĕ`</summary>
	bool DrawRotateAxis(int x,int y,int X,int Y,double g嗦,double px,bool ]tO = false ) const
	{
		return !DxLib::DrawRotaGraph2( x , y , X , Y , g嗦 , px , this->GetHandle() , this->isTrans , ]tO );
	}
	bool ZMaskRotateAxis(int x,int y,int X,int Y,double g嗦,double px, ZMaskType Z}XN^Cv , bool ]tO = false ) const
	{
		return !DxLib::DrawRotaGraph2ToZBuffer( x , y , X , Y , g嗦 , px , this->GetHandle() , (int)Z}XN^Cv , ]tO );
	}

	/// <summary>]ApxAg嗦cʂɎw肵ĕ`</summary>
	bool DrawRotateAxis(int x,int y,int X,int Y,double g嗦X,double g嗦Y,double px,bool ]tO =false) const
	{	
		return !DxLib::DrawRotaGraph3( x , y , X , Y , g嗦X , g嗦Y , px , this->GetHandle() , this->isTrans , ]tO );
	}
	bool ZMaskRotateAxis(int x,int y,int X,int Y,double g嗦X,double g嗦Y,double px, ZMaskType Z}XN^Cv , bool ]tO = false) const
	{
		return !DxLib::DrawRotaGraph3ToZBuffer( x , y , X , Y , g嗦X , g嗦Y , px , this->GetHandle() , (int)Z}XN^Cv , ]tO );
	}

	/// <summary>lp`ɕό``</summary>
	bool DrawModify(int x1,int y1,int x2,int y2,int x3,int y3,int x4,int y4 ) const
	{
		return !DxLib::DrawModiGraph( x1 , y1 , x2 , y2 , x3 , y3 , x4 , y4 , this->GetHandle() , this->isTrans );
	}
	bool ZMaskModify(int x1,int y1,int x2,int y2,int x3,int y3,int x4,int y4 , ZMaskType Z}XN^Cv) const
	{
		return !DxLib::DrawModiGraphToZBuffer( x1 , y1 , x2 , y2 , x3 , y3 , x4 , y4 , this->GetHandle() , (int)Z}XN^Cv );
	}

	/// <summary>C[Ẅꕔw肵ĕ`</summary>
	bool DrawPart(int destX,int destY,int srcX, int srcY, int , int , bool ]tO ) const
	{
		return !DxLib::DrawRectGraph( destX , destY , srcX , srcY ,  ,  , this->GetHandle() , this->isTrans , ]tO );
	}
	bool ZMaskPart(int destX,int destY,int srcX, int srcY, int , int  , ZMaskType Z}XN^Cv , bool ]tO = false) const
	{
		return !DxLib::DrawRectGraph( destX , destY , srcX , srcY ,  ,  , this->GetHandle() , (int)Z}XN^Cv , ]tO );
	}

	///<summary>XN[̈ꕔC[WɎ荞</summary>
	///w肵WEɂāAXN[ImageƓ傫Rs[
	int LoadScreen(int x,int y)
	{
		int w,h;
		DxLib::GetGraphSize( this->GetHandle() , &w , &h );
		return DxLib::GetDrawScreenGraph( x , y , x + w , y + h , this->GetHandle() );
	}
			
	/// <summary>擾</summary>
	int GetWidth() const
	{
		return width;
	}
			
	/// <summary>擾</summary>
	int GetHeight() const
	{
		return height;
	}
			
	/// <summary></summary>
	bool GetIsScreen() const
	{
		return this->isScreen;
	}
			
	/// <summary>`ltO擾</summary>
	bool GetIsAlphaChannel() const
	{
		return this->isAlphaChannel;
	}
			
	/// <summary>߃tO擾</summary>
	bool GetIsTrans() const
	{
		return this->isTrans;
	}
	
	///<summary>`ɂ̃C[WɎw</summary>
	///Image::MakeŃXN[tOtrueɂꍇB
	bool SetDrawScreen()
	{
		if(this->isScreen)
		{
			return !DxLib::SetDrawScreen( this->GetHandle() );
		}
		return false;
	}
};
	
///	<summary>Image܂Ƃ߂NX</summary>
///	<example>
///	[TvR[h:]<br></br>
/// Tv<br></br>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<br></br>
///	{<br></br>
///		if( !Dx::Initialise() ) return -1;<br></br>
///		Dx::End();<br></br>
///		return 0;<br></br>
/// }<br></br>
/// </code>	
/// </example>
class ImagePack
{
protected:
	std::vector<Image*> images;
	int widthMax;
	int heightMax;
public:
	ImagePack():
		widthMax( 0 ),
		heightMax( 0 )
	{}
			
	///<summary>P̉摜𕪊ēǂݍ</summary>
	ImagePack( const char *t@C , int R} , int R}艡,int R}c,int R},int R} )
	{
		ImagePack::Load(t@C,R} , R}艡, R}c , R} , R} );

		int *buf = new int[R}];

		if( DxLib::LoadDivGraph(t@C,R},R}艡,R}c,R},R},buf) == 0 )
		{
			for(int i=0;i<R};i++)
			{
				this->Add( new Image(buf[i]) );
			}
		}

		delete [] buf;
	}

	///<summary>P̉摜𕪊ēǂݍ</summary>
	///R}=14,R}艡=4,R}c=4̏ꍇ
	///[ 0][ 1][ 2][ 3]
	///[ 4][ 5][ 6][ 7]
	///[ 8][ 9][10][11]
	///[12][13][  ][  ]
	///̂悤ɕāAImagePack̃TCY14ɂȂ
	virtual bool Load(const char *t@C , int R},int R}艡, int R}c ,int R},int R} )
	{
		int *buf = new int[R}];

		if( DxLib::LoadDivGraph(t@C,R},R}艡,R}c,R},R},buf) == 0 )
		{
			for(int i=0;i<R};i++)
			{
				this->Add( new Image(buf[i]) );
			}
		}

		delete [] buf;
		return true;
	}

	///<summary>Aԃt@Cꊇēǂݍ</summary>
	/// t@ČɎO̘AԂtt@CAēǂݍ
	/// ut@C***.gqv
	virtual bool Load(const char *t@C , const char *gq , int R} )
	{
		for(int i=0 ; i<R} ; i++)
		{ 
			char fileBuf[8];
			sprintf_s( fileBuf , 8 , "%03d." , i );

			std::string fileName = t@C;
			fileName += fileBuf;
			fileName += gq;

			this->Add( new Image( fileName.c_str() ) );
		}
		return true;
	}
			
	///<summary>C[Wǉ</summary>
	///C[W𖖔ɒǉB
	virtual void Add(Image *ǉC[W)
	{
		images.push_back( ǉC[W );
					
		this->widthMax  = max( this->widthMax  , ǉC[W->GetWidth() );
		this->heightMax = max( this->heightMax , ǉC[W->GetHeight() );
	}
	virtual void Add(const char *t@C)
	{
		Add( new Image( t@C ) );
	}
			
	/// <summary>C[WJ</summary>
	virtual void Release()
	{
		for( auto it : images)
		{
			it->Release();
		}

		images.clear();
	}
			
	/// <summary>vf擾</summary>
	int GetSize() const
	{
		return images.size();
	}
				
	/// <summary>ő啝擾</summary>
	int GetWidth() const
	{
		return this->widthMax;
	}
			
	/// <summary>ő卂擾</summary>
	int GetHeight() const
	{
		return this->heightMax;
	}
	
	Image* operator[](int index)
	{
		return images[index];
	}
};	
}