#pragma once
#include"DxLib.h"
#include"Image.h"
#define NULL_HANDLE -1

namespace DXFW
{
/// <summary>ǗNX</summary>
/// <example>
/// [TvR[h:]<BR>
/// Tv<BR>
/// <code>
/// int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
/// {<BR>
///		if( !Dx::Initialise() ) return -1;<BR>
///		Dx::End();<BR>
///		return 0;<BR>
/// }<BR>
/// </code>	
/// </example>
class Movie
{
private:
	std::string fileName;
public:
	
	/// <summary>t@C̓o^</summary>
	Movie(const char *t@C)
	{
		this->fileName = t@C;
	}
	
	///<summary>t@C̓o^</summary>
	///[r[t@Co^B
	///ɂ͓ǂݍ܂ȂB
	bool Load(const char *t@C)
	{
		this->fileName = t@C;
		return true;
	}

	///<summary>Đ</summary>
	///g͐{̂
	///rLZtOtruȅꍇAĐɓ͂ƓrōĐ𒆒f
	bool Play(int g嗦 , bool rLZtO)
	{
		if( rLZtO )
		{
			PlayMovie( fileName.c_str() , g嗦 , DX_MOVIEPLAYTYPE_BCANCEL ) ;
		}else{
			PlayMovie( fileName.c_str() , g嗦 , DX_MOVIEPLAYTYPE_NORMAL ) ;
		}
	}
};
	
///<summary>
///ImageNX̓
///</summary>
///<example>
///[TvR[h:]<BR>
///Tv<BR>
///<code>
///int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///{<BR>
///	if( !Dx::Initialise() ) return -1;<BR>
///	Dx::End();<BR>
///	return 0;<BR>
///}<BR>
///</code>	
///</example>
class MovieImage
{
private:
	int handle;
	bool isTrans;
	MovieImage(const MovieImage &movie);
	MovieImage& operator =(const MovieImage &movie);
public:
	MovieImage():
		isTrans(false),
		handle( NULL_HANDLE )
	{}
	
	///<summary>t@C̓Ǎ</summary>
	MovieImage(const char *t@C)
	{
		this->handle = DxLib::LoadGraph(t@C);
	}

	///<summary>t@C̓Ǎ</summary>
	///t@CɓǂݍށB
	int Load(const char *t@C)
	{
		if(this->handle != NULL_HANDLE) DxLib::DeleteGraph(this->handle);
		this->handle = DxLib::LoadGraph(t@C);
		return this->handle;
	}

	///<summary>t@C̊J</summary>
	///t@CJB
	bool Release()
	{
		return !DxLib::DeleteGraph(this->handle);
	}

	///<summary>nh̎擾</summary>
	int GetHandle()
	{
		return this->handle;
	}
	
	///<summary>̍Đ</summary>
	bool Play()
	{
		return !DxLib::PlayMovieToGraph( this->handle );
	}
	
	///<summary>̒~</summary>
	bool Pause()
	{
		return !DxLib::PauseMovieToGraph( this->handle ) ;
	}
	
	///<summary>̍Đʒuݒ</summary>
	int Seek(int time)
	{
		return DxLib::SeekMovieToGraph( this->handle , time ) ;
	}
	
	///<summary>̍Đʒu擾</summary>
	int Tell()
	{
		return DxLib::TellMovieToGraph( this->handle ) ;
	}
	
	///<summary>悪Đ擾</summary>
	bool Check()
	{
		return (DxLib::GetMovieStateToGraph( this->handle ) == 1);
	}
	
	/// <summary>wWɕ`</summary>
	bool Draw(int x,int y , bool isTurn = false)
	{
		if( isTurn ) return !DxLib::DrawTurnGraph( x , y , this->handle , this->isTrans );
		else		 return !DxLib::DrawGraph( x , y , this->handle , this->isTrans );
	}

	/// <summary>w`ɕ`</summary>
	bool DrawExtend(int x1,int y1,int x2,int y2)
	{
		return !DxLib::DrawExtendGraph( x1 , y1 , x2 , y2 , this->handle , this->isTrans );
	}

	/// <summary>pxAg嗦w肵ĕ`</summary>
	bool DrawRotate(int x,int y,double extRate,double angle,bool isTurn)
	{
		return !DxLib::DrawRotaGraph( x , y , extRate , angle , this->handle , this->isTrans , isTurn );
	}
	
	/// <summary>pxAg嗦w肵ĕ`</summary>
	bool DrawRotateAxis(int x,int y,int cx,int cy,double extRate,double angle,bool isTurn)
	{
		return !DxLib::DrawRotaGraph2( x , y , cx , cy , extRate , angle , this->handle , this->isTrans , isTurn );
	}
	
	/// <summary>]ApxAg嗦w肵ĕ`</summary>
	bool DrawRotateAxis(int x,int y,int cx,int cy,double extRateX,double extRateY,double angle,bool isTurn)
	{
		return !DxLib::DrawRotaGraph3( x , y , cx , cy , extRateX , extRateY , angle , this->handle , this->isTrans , isTurn );
	}
	
	/// <summary>]ApxAg嗦cʂɎw肵ĕ`</summary>
	bool DrawModify(int x1,int y1,int x2,int y2,int x3,int y3,int x4,int y4)
	{
		return !DxLib::DrawModiGraph( x1 , y1 , x2 , y2 , x3 , y3 , x4 , y4 , this->handle , this->isTrans );
	}
	
	/// <summary>C[Ẅꕔw肵ĕ`</summary>
	bool DrawPart(int destX,int destY,int srcX, int srcY, int width, int height, bool isTurn)
	{
		return !DxLib::DrawRectGraph( destX , destY , srcX , srcY , width , height , this->handle , this->isTrans , isTurn );
	}
	
	/// <summary>擾</summary>
	int GetWidth()
	{
		int w,h;
		DxLib::GetGraphSize( this->handle , &w , &h );
		return w;
	}
	
	/// <summary>擾</summary>
	int GetHeight()
	{			
		int w,h;
		DxLib::GetGraphSize( this->handle , &w , &h );
		return h;
	}

};
}